<?php
###############################################
#                                             #
# BTsource torrent upload and process page    #
# Writtern 26/07/05							  #
#								              #
###############################################

/*-------------------
# First check if they have permission to upload
#------------------*/

if($u['can_upload'] != '1'){
	echo $lang['upload_noperm'];
	kill();
}

/*-------------------
# Then check if we have post data...
#--------------------*/

if(isset($_POST['submit']) && $_POST['catid'] !== 'FALSE'){
	
	/*-----------------------
	# ok we have post data now check if we actually have a .torrent and cats selected...
	#----------------------*/
	if(!isset($_FILES) || !isset($_POST['catid'])){
	
		/*-------------------------------------
		#output the upload form, and inform the user of their error
		#------------------------------------*/
		upload_form($_POST,$fileerror);
	}
	
	/*---------------------
	# Now run various "tests" on the torrent"
	#--------------------*/
	
	$ext = array('.torrent', '.torrent2');
	
	//make sure we have set the upload path
	if(!isset($_CFG['upload_path'])){
		echo'<div class="error">'.$lang['upload_patherror'].'</div>';
	
		//now check for "erronous errors"
	}elseif ($_FILES['torrent']['error'] != '0'){
		$error = array(
      	1=>"The uploaded file exceeds the upload_max_filesize directive in php.ini",
      	2=>"The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
      	3=>"The uploaded file was only partially uploaded",
      	4=>"No file was uploaded",
      	6=>"Missing a temporary folder"
		);
		echo'<div class="error">'.$error[$_FILES['torrent']['error']].'</div>';
	
		//we ARE uploading a torrent arnt we?	
	}elseif (!in_array(strrchr($_FILES['torrent']['name'],'.'),$ext)){
		echo'<div class="error">'.$lang['upload_nottorrent'].'</div>';
	}else{
		
		/*----------------------------
		# OK everything checks out, lets do this....
		#---------------------------*/
		
		//firstly decode the torrent :)
		$torrent = bdec_file($_FILES['torrent']['tmp_name'], 1 << 20);
		$info_hash = pack('H*', sha1($torrent['value']['info']['string']));
		$chash = sha1(benc($torrent['value']['info']));
		$pcount = $torrent['value']['info']['value']['pieces']['strlen'] / 20;
		$plength = $torrent['value']['info']['value']['piece length']['value'];
		$size = $pcount * $plength;
		$announce = $torrent['value']['announce']['value'];
				
		//now check were using the correct announce url
		if($announce != $_CFG['trackerannounce']){
			echo'<div class="error">'.$announce.$lang['upload_invalidannounce'].'</div>';
			kill();
		}

		//do we have a valid file name?
		if(!isset($_POST['name']) || $_POST['name'] == ''){
			$name = substr($_FILES['torrent']['name'],0,-8);
		}else{
			$name = $_POST['name'];
		}
		
		//get the cat and subcat id's
		list($catid,$subcat) = explode('_',$_POST['catid']);
		$catid = addslashes(stripslashes($catid));
		$subcat = addslashes(stripslashes($subcat));
		
		/*-------------------------
		# Get the file contense
		#-------------------------*/
		$files = $torrent['value']['info']['value']['files']['value'];
		$info = $torrent['value']['info']['value'];
		
		//get ['files'] ready to put into the query...
		$sql_files = '';
		$bytes = '';
		if(is_array($files)){
			foreach($files as $k => $v){
				$sql_files .= $v['value']['path']['value'][count($v['value']['path']['value'])-1]['value'];
				if(count($files) > $k +1){
					$sql_files .=',';
				}
			}
		}else{
			$sql_files = $torrent['value']['info']['value']['name']['value'] . ',';
		}
		
		/*------------------------
		# Clean up the description, if theres none set set one!
		#-----------------------*/
		if(!isset($_POST['comment'])){
			//set it to 'None'
			$comment = 'None';
		}else{
			$comment = pase_input($_POST['comment']);
		}
		
		/*----------------------
		# Check the torrent dosnt already exist!
		#----------------------*/
		$res = cmysql_query("SELECT count(`torrentid`) as count FROM `".SQL_PREFIX."torrents` WHERE `info_hash` = '".$info_hash."'");
		$count = mysql_fetch_array($res);
		if($count['count']>0){
			echo'<div class="header">'.$lang['global_error'].'</div>'.$lang['upload_alreadyexist'];
			kill();
		}
		
		/*----------------------
		# Now lets start inserting the data
		#---------------------*/
		// Do we have moderated uploads enabled & can we bypass the moderation process?
		if($_CFG['self_moderation'] == '1'){
			if($u['buypass_moderation'] == '1'){
				$mod = $u['uid'];
			}else{
				$hidden = '1';
			}
		}
		
		// Insert the data into the xbt_files table (setting the flag if were moderated)
		$xbt = cmysql_query('INSERT IGNORE INTO `'.X_SQL_PREFIX.'files` (`info_hash`, `ctime`, `flags`) VALUES (\''.$info_hash.'\', null, \''.addslashes($hidden).'\')');
		$xbtid = mysql_insert_id();
		
		// Insert the data into the bts_torrents table
		$bts = 'INSERT IGNORE INTO `'.SQL_PREFIX.'torrents` (`fid`, `name`, `filename`, `announce`, `catid`, `subcat`, `files`, `info`, `filesize`, `info_hash`, `info_hash2`, `description`, `submitter`, `ip`, `submit_date`, `hidden`, `moderator`) VALUES
		(\''.$xbtid.'\', \''.$name.'\', \''.$_FILES['torrent']['name'].'\', \''.$announce.'\', \''.$catid.'\', \''.$subcat.'\', \''.$sql_files.'\', \''.$_POST['info'].'\', \''.$size.'\', 
		\''.$info_hash.'\', \''.$chash.'\', \''.$comment.'\', \''.$u['uid'].'\', \''.$_SERVER['REMOTE_ADDR'].'\', \''.time().'\', \''.$hidden.'\', \''.$mod.'\')';
		
		cmysql_query($bts);
		
		//get the torrents id from the database :)
		$id = mysql_insert_id();
		
		/*-----------------
		# Now we wanna move the .torrent
		#----------------*/
		
		if(move_uploaded_file($_FILES['torrent']['tmp_name'], $_CFG['upload_path'].'/'.$id.'.torrent')){
			//upload successful now what?
			if($hidden == '1'){ 
				//if were moderated output the "upload successful but moderated" form
				echo $lang['upload_successhid'];
			}
			else
			{
				// if were NOT moderated output the success, and show where we can find the torrent :)
				echo str_replace('%id%', $id, $lang['upload_success']);
			}
		}
		else 
		{
			// So there was a problem with taking the .torrent, so we delete the info from the db, and tell the user to try again :)
			cmysql_query('DELETE FROM `'.SQL_PREFIX.'torrents` WHERE `id` = '.$id);
			cmysql_query('DELETE FROM `'.X_SQL_PREFIX.'files` WHERE info_hash = '.$hash);
			echo $lang['upload_failed'];
		}
	}
}
else 
{
	/*-------------------
	# No forms submitted, so we output the form :)
	#------------------*/
	//if we did submit the form but forgot to select a category tell the user that.
	if($_POST['catid'] == 'FALSE'){
		$false = $lang['upload_catfalse'];
	}
	//output upload rules/guidlines/msg
	echo $lang['upload_formmsg']. '<br /><br />';
	//tell the user what announce url to use
	echo $lang['upload_tracker']. '<br /><br /><b>'.$_CFG['trackerannounce'].'</b><br /><br />';
	//now create the form 
	echo'<form name="upload" enctype="multipart/form-data" method="POST" action="'.$_CFG['boardurl'].'/?page=upload">
	<table cellpadding="3" cellspacing="0" border="0">
	<tr><td>'.$lang['upload_formname'].'</td><td><input type="text" name="name" size="48"></td></tr>
	<tr><td>'.$lang['upload_formtorrent'].'</td><td><input type="file" name="torrent" accepted="application/x-bittorrent" size="36"></td></tr>
	<tr><td>'.$lang['upload_formcat'].'</td><td><select name="catid"><option value="FALSE"> -=[ SELECT ONE ]=- </option>'.cat_list().'</select>'.$false.'</td></tr>
	<tr><td>'.$lang['upload_infolist'].'</td><td><input type="text" name="info" size="48"></td></tr>
	<tr><td>'.$lang['upload_formdesc'].'</td><td><textarea name="comment" rows=7 cols=45>None</textarea></td></tr>
	<tr><td colspan="2" align="center"><input type="submit" value="Upload" name="submit"></td></tr>
	</table>
	</form>';
}		 
?>