<?php
/*-----------------------------------------
#
# Btsource main index page, rewrittern
# 25/07/05.
#
#----------------------------------------*/	

/*------------------
#setting the time counter, DONT add anything above this...
#------------------*/
$starttime = microtime();

/*-----------------
#set the version number
#----------------*/
$version = '0.4';

/*-----------------
# Start the session if were using sessions
#----------------*/
@session_start();

/*-----------------
# Load the MAIN conf file
#-----------------*/
require_once('static-config.php');
define(SQL_PREFIX, $_CFG['tbl_prefix']);
define(X_SQL_PREFIX, $_CFG['xbt_tbl_prefix']);

/*-----------------
# Get all libraries
#-----------------*/
require_once('libs/libs.inc.php');

/*-----------------
# Get all included files
#----------------*/
require_once('includes/includes.inc.php');


/*----------------
#Check to see if were logged in and get the user permissions...
#---------------*/
$u = permcheck();

/*----------------
# Cleanup on isle 4
#---------------*/
if($_CFG['clean_last_run'] < time() - 3600){
	cleanup();
} 

/*----------------------------------------------------------------
# Determine the page to use, to add a new ?page= look below.
#
# syntax, 'pagename' => array('file name (location)','Page title','Div header','must bee logged in?','load header?', 'dynamic querys page?' 'languagefile (leave blank for none)'), 
#-----------------------------------------------------------------*/
$pages = array(
	'home'  		=> array('home.page.php', 'meh', 'Welcome to meh', '0','1', '0', 'home.lang.php'),
	'login'  		=> array('login.page.php', 'Login', 'Login', '0', '1', '0'),
	'usercp' 		=> array('usercp.page.php', 'UserCP', 'Usercp', '1', '1', '0', 'usercp.lang.php'),
	'upload'		=> array('upload.page.php', 'Upload', 'Upload', '1', '1', '0', 'usercp.lang.php'),
	'torrents'	 	=> array('torrents.page.php', 'Browse', 'Browse Torrents','1', '1', '0'),
	'signup'		=> array('signup.page.php', 'Signup', 'Signup', '0', '1', '0', 'signup.lang.php'),
	'modcp'			=> array('modcp.page.php', 'ModCP', 'ModCP', '1', '1', '0'),
	'torrentinfo'	=> array('torrentinfo.page.php', 'Torrentinfo', 'torrentinfo', '0', '1', '1','tinfo.lang.php'),
	'search'		=> array('search.page.php', 'Search', 'Search', '1', '1', '0'),
	'vote'			=> array('vote.page.php', 'Vote', 'Vote', '1', '1', '0'), 	
	'rss'			=> array('rss.page.php', 'rss', 'rss', '0', '0', '0'),
	'download'		=> array('download.page.php', 'download', 'download', '0', '0', '0','download.lang.php'),
	'admincp'		=> array('admincp.page.php', 'admincp', 'admincp', '1', '1', '0')
 );
 
//if theres no page= selected then return home.page.php 
$page = $_GET['page']; 
if(!isset($page)){
	$page = 'home';
}

//if were logging out send up back home :)
if($page == 'logout'){
	header('Location: '.$_CFG['boardurl']);
}

//do we have to bee logged in to view this page?
if($pages[$page][3] == '1' && isguest()){
	header('Location:'.$_CFG['boardurl'].'/?page=login');
	die();
}

//dose the page actually exist in the array above? dont want nasty errors do we :P
if(!isset($pages[$page])){
	$title = 'Error: 404';
	$divheader = 'Error: 404';
	require('./includes/header.page.php');
	echo'The page you requested dosen\'t exist';
	require('./includes/footer.page.php');
	@mysql_close($db);
	exit();		
}

//turn the page array into indivudual variables
list($file,$title,$divheader,$login,$head,$pquery,$lfile) = $pages[$page];

/*-------------------
# do we want to load the pre-query file? (for dynamic titles)
#------------------*/
if($pquery == '1'){
	require_once('pages/misc/querys.misc.php');
}
/*-------------------
#load the language files.
#-------------------*/
require('./lang/'.$u['langdir'].'/global.lang.php');
if(isset($lfile)){
	require('./lang/'.$u['langdir'].'/'.$lfile);
}

/*-----------------
# are we loading a headerless page?
#-----------------*/
if($head == '0'){
	//but first check the file actually exists, (dont want nasty include errors :) )
	if(file_exists('./pages/'.$file)){
		include('./pages/'.$file);
		
	}else{
		$title = 'Error: 404';
		$divheader = 'Error: 404';
		require('./includes/header.page.php');
		echo'We appear to have missplaced this file, sorry';
		require('./includes/footer.page.php');
		@mysql_close($db);
		exit();
	}
}
else
{
	/*-------------------
	#load the sites header
	#-------------------*/
	require('./includes/header.page.php');


	/*-------------------
	#display the requested page
	#-------------------*/

	//but first check the file actually exists, (dont want nasty include errors :) )
	if(file_exists('./pages/'.$file)){
		include('./pages/'.$file);
	}else{
		echo'We appear to have missplaced this file, sorry';
		require('./includes/footer.page.php');
		@mysql_close($db);
		exit();
	}

	/*-----------------
	# Load the footer page
	#----------------*/
	require('./includes/footer.page.php');

}

/*-------------------
# Update the last seen
#-------------------*/
if($_CFG['log_last_action'] == '1'){
	//are we a user or guest?
	if($u['gid'] != $_CFG['class_guest']){
		cmysql_query('UPDATE '.SQL_PREFIX.'users SET last_seen = \''.time().'\', last_seen_where = \''.$u['last_seen_where'].'\' WHERE uid = \''.$u['uid'].'\'');
	}/*else{
		cmysql_query('INSERT INTO '.SQL_PREFIX.'guest_sessions (ip, last_seen, last_seen_where) VALUES (\''.$_SERVER['REMOTE_ADDR'].'\', \''.time().'\', \''.$u['last_seen_where'].'\')');
	}*/
}

/*-------------------
# Kill the database
#-------------------*/
@mysql_close($db);
?>