<?
###################################
#                                 #
# Btsource main site functions    #
# Written 20/08/05                #
#                                 #
###################################

/*------------------
# Generates the wate time, this is just a temp function
# it will bee made editable via the acp soon
#------------------*/
function get_wate_time($u)
{
        if($u['bypass_ratio'] == '1'){
                $wt =  '0'; //watetime of 0 if you select that group to be able to bypass the restriction
        }elseif($u['ratio'] == 'infinate'){
                $wt = '0';
        }elseif($u['ratio'] > '2.00'){
                $wt = '0'; // wate time of 0
        }elseif($u['ratio'] > '1.00'){
                $wt = '2' * '60' * '60'; //wate time of 2 hours
        }elseif($u['ratio'] > '0.75'){
                $wt = '12' * '60' * '60'; //wate time of 12 hours
        }elseif($u['ratio'] > '0.50'){
                $wt = '24' * '60' * '60'; //wate time of 24 hours
        }else{
                $wt = '48' * '60' * '60'; //wate time of 48 hours
        }
        return $wt;
}

/*-------------------
# Counts the queries and outputs the error if it fails
#------------------*/
function cmysql_query($sql=FALSE)
{
	//load the amount of querys already processed
	static $queries = 0;
	
	//if were not passing through a query then output the number of querys we have executed
	if (!$sql)
		return $queries;

	//increment $queries	
	$queries ++;

	//so we ARE running a query, so lets do it then
	$query = mysql_query($sql);

	if(!$query){
		//it didnt work so lets error
        echo'There was an error in your query.<br /><br />Please review the query executed below to debug the error<br /><br />
        <center><textarea rows="20" cols="100">'.mysql_error()."\n\n$sql</textarea></center><br /><br />";
        kill();
    }
    else
    {
        //the query functioned fine, so lets pass the data back :)	
		return $query;
	}

}

/*----------------
# Converts raw bytes into the approte KB, MB etc
# (got lazy and stole this from bytmonsoon
#----------------*/
function byte2mbyte($in){
	if($in == 0 || !isset($in))
		return '0 KB';
	if($in < 1000 * 1024)
		return round($in / 1024, 2).' KB';
	if($in < 1000 * 1048576)
		return round($in / 1048576).' MB';
	if($in < 1000 * 1073741824)
		return round($in / 1073741824).' GB';
	return round($in / 1099511627776, 2).' TB';
}

/*------------
# Generate the category list for upload page and modcp
#------------*/
function cat_list(){
	//load the globals
	global $_CFG;
	
	//do we want to use subcats? or just main cats?
	if($_CFG['use_subcats'] == '1'){
		//ok so we want to use subcats so lets query the db 
		$res = cmysql_query('SELECT  `catid`, `name`, `parent` FROM `'.SQL_PREFIX.'cats` ORDER BY  `parent` ASC');
		while(list($catid,$name,$parent) = @mysql_fetch_row($res)){
			if($parent==0)
			{
				$parentcat[$catid] = stripslashes($name);
			}
			else
			{
				$subcat[$parent.'_'.$catid] = $parentcat[$parent].' - '.stripslashes($name);
			}
		}
		if(count($subcat)>0){
			foreach($subcat as $ind => $val){
				$option .='<option value="'.$ind.'">'.$val.'</option>';
			}
		}
	}
	else 
	{
		$sql = 'SELECT `catid`, `name` FROM `'.SQL_PREFIX.'cats` WHERE `parent` = 0 ORDER BY `name` ASC';
		$res = @cmysql_query($sql);
		while($row = mysql_fetch_array($res)){
			$option .= '<option value="'.$row['catid'].'">'.$row['name'].'</option>';
		}
	}
	return $option;
}

/*----------------
# This is to be used for stuff like modcp redirects
#----------------*/

function get_form_url(){
	if(!isset($_GET['page'])){
		$url = '';
	}else{
		$url = '?page='.$_GET['page'];
		if(isset($_GET['op']))
			$url .='&op='.$_GET['op'];
		if(isset($_GET['term']))
			$url .='&term='.$_GET['term'];
		if(isset($_GET['cat']))
			$url .='&cat='.$_GET['cat'];
		if(isset($_GET['catid']))
			$url .='&catid='.$_GET['catid'];
		if(isset($_GET['subcat']))
			$url .='&subcat='.$_GET['subcat'];
		if(isset($_GET['tid']))
			$url .='&tid='.$_GET['tid'];
	}
	return $url;
}

/*--------------
# This is used to generate the passkey AND for
# the signup secret key thanks to xft for this.
#--------------*/

function generate_torrent_pass(){
	
	//set the allowed chars
	$a='0123456789abcdefghijklmnopqrstuvwxyz';
	$v = '';
	//set the number of chars to output
	for($i = 0; $i < 32; $i++)
		//randomize.....
		$v .=$a[rand() % strlen($a)];
	//return
	return $v;
}

/*-----------
# page generated in...
#----------*/
function microtime_diff($a,$b){
	list($a_dec, $a_sec) = explode(" ", $a);
	list($b_dec, $b_sec) = explode(" ", $b);
	return $b_sec - $a_sec + $b_dec - $a_dec;
}

/*----------
# w00t the shoutbox!
#----------*/
function shoutbox(){
	
	//load the globals
	global $_CFG, $u;
	//are we submitting a shout?
	if($_POST['Shout'] == 'Shout' && isset($_POST['msg'])){
		//if so lets make sure theres no nastys in the $msg
		$msg = pase_input($_POST['msg']);
		//inset into the db
		cmysql_query('INSERT INTO `'.SQL_PREFIX.'shoutbox` (`msg`, `uid`, `time`) VALUES (\''.$msg.'\', \''.$u['uid'].'\', '.time().')');
	}
	//ok we've added what need to bee, lets generate the shoutbox :)
	
	echo'<table class="tlist"><tbody><tr class="thead"><td>latest shouts</td></tr>';
	
	//ok lets run the query
	$shout = cmysql_query('SELECT s.msg, s.time, s.uid,
							u.username,
							ug.openhtml, ug.closehtml, ug.class
							FROM '.SQL_PREFIX.'shoutbox s
							LEFT JOIN '.SQL_PREFIX.'users u ON u.uid=s.uid
							LEFT JOIN '.SQL_PREFIX.'usergroups ug ON ug.gid=u.class
							ORDER BY s.time DESC LIMIT 5');
	while($row = mysql_fetch_array($shout)){
		if(!$row){
			//if no shouts has ever been made tell them so
			echo'<tr><td>No shouts posted</tr></td></table>';
		}else{
			if(!isset($row['uid']) || $row['uid'] == '' || $row['uid'] == '0'){
				//set the guest variables :)
				$row['username'] = 'Guest';
				$row['openhtml'] = '<i>';
				$row['closehtml'] = '</i>';
			}
			//output the shouts \o/
			echo'<tr><td>'.$row['openhtml'].$row['username'].$row['closehtml'].' ('.date("d-F H:i", $row['time']).') -- '.$row['msg'].'</td></tr>';
		}
	}
	//do we have permission to shout?
	if($u['can_shout'] == '1'){
		//if so output the form
		echo'<tr><td><form method="POST" action="'.$_CFG['boardurl'].'/'.get_form_url().'"><br />
		Enter Message: <input type=textbox" size="80" name="msg"><input type="submit" name="Shout" value="Shout"></form></td></tr></table>';
	}else{
		//no shouting here :P
		echo'<tr><td><b>Error:</b> You dont have permission to use the shoutbox</td></tr></table>';
	}
}

/*------------
# Page linker
#------------*/
function linker($limit=FALSE){
	
	//load the globals
	global $_CFG;
	
	if($limit){
		//if were passing a limit through the function
		//then we use that, else we use the $_CFG value
		$max = $limit;
	}else{
		$max = $_CFG['max_list_torrents'];
	}
	$page = (int)$_GET['tl_page'];
	if(!isset($page)){
		$page = 1;
	}
	if($page<1){
		$page_list = 'Page 1';
		$page = 1;
		$sort = ' LIMIT '.$max;
	}else{
		$page_list = 'Page '.$page;
		$offset = $page * $max - $max;
		$sort = ' LIMIT '.$max.','.$offset;
	}
	return $page_list.'_'.$sort.'_'.$page;
}

/*-------------
# Cuts the end of a name if it too big 
#-------------*/
function torrent_truncate($in,$length=FALSE){
	if(!length){
		$length = $GLOBALS['_CFG']['torrenr_namelen'];
	}
	if(strlen($in)>$length){
		return (substr($in,0,$length).'...');
	}else{
		return $in;
	}
}
	
/*-------------
# Kill function, bascally die() that loads the footer file :)
#-------------*/
function kill(){
	global $_CFG, $starttime, $u;
	
	require_once('./includes/footer.page.php');
	die();
}

/*------------
# General cleanup of dead torrents
# and old db info
#------------*/
function cleanup(){
		
	//ok firstly lets find dead but displaying torrents 
	$query = cmysql_query("UPDATE ".SQL_PREFIX."torrents t cross join ".X_SQL_PREFIX."files x on t.info_hash = x.info_hash SET t.dead = 1, t.dtime = ".time()." WHERE x.seeders = 0 AND x.leechers = 0 AND submit_date < ".time()." - 86400");
	$set1 = mysql_affected_rows();

	//now lets unset the dead tag on live torrents
	$query = cmysql_query("UPDATE ".SQL_PREFIX."torrents t cross join ".X_SQL_PREFIX."files x on t.info_hash = x.info_hash SET t.dead = 0 WHERE x.seeders > 0 OR x.leechers > 0");
	$set2 = mysql_affected_rows();
	
	//permanantly delete torrents dead for more then x days
	/*I decided a permanant auto delete option was a bad idea in the end
	so i have removed the code i added for this, This is because should your
	site ever go offline for more then x days ALL torrents on the site will 
	naturally bee deleted ill come up with someway to prevent this in a future 
	release for now i think ill add an option in the acp to purge dead torrents including
	- ALL db refences to it
	- the actual .torrent from the uploads folder
	- vote tallys for it
	- comments stored for it etc
	*/
	
	//now lets purge validating users that havent validated after 3 days
	
	//suppose we should check we've enabled required validation first
	if($_CFG['register_validation'] == '1')
	{
		$query = cmysql_query("SELECT `uid` FROM `".SQL_PREFIX."users` WHERE `reg_date` < ".time()." - 259200 AND `class` = '".$_CFG['class_validating']."'");
		while($res = mysql_fetch_array($query)){
			
			$cleancount++;
			//set the array so we dont overight it
			$uid[$res['uid']] = $res['uid'];
		}
		
		if($cleancount>0){		
			//setup the $tag (to "tag" onto the end of the querys)
			foreach($uid as $k){
				$tag .= ' `uid` = '.$k.' AND';
			} 
		
			//strip the last 4 chars from the querys (the " AND") and run the querys
			cmysql_query(substr('DELETE FROM `'.SQL_PREFIX.'users` WHERE'.$tag, 0, -4));
			cmysql_query(substr('DELETE FROM `'.SQL_PREFIX.'votes` WHERE'.$tag, 0, -4));
			cmysql_query(substr('DELETE FROM `'.X_SQL_PREFIX.'users` WHERE'.$tag, 0, -4));
			cmysql_query(substr('DELETE FROM `'.X_SQL_PREFIX.'files_users` WHERE'.$tag, 0, -4));
		}
	}
	
	//cleanup guest sessions
	//$query = mysql_query("DELETE from guest_sessions WHERE lastseen < ".time()." -900");
	
	//delete inactive users if we have the function set
	//This one hasne been tested yet and because of its perminant 
	//natur im NOT going to activate till through testing :)
	/*if($_CFG['user_delete'] > 0)
	{
		$count = 0;
		$deltime = (($_CFG['user_delete'] * 24) * 60) * 60; 
		$query = mysql_query("SELECT `uid` from `users` WHERE `last_on` > ".time() - $deltime);
		while($res = mysql_fetch_array($query)){
			
			//set the array so we dont overight it
			$uid[$res['uid']] = $uid[$res['uid']];
		}
		
		//setup the $tag (to "tag" onto the end of the querys)
		foreach($uid as $k){
			$count++;
			$tag .= ' `uid` = '.$k.' AND';
		} 
		
		//ONLY run the 4 querys IF we have someone to delete ;->
		if($count > 0){
			//strip the last 4 chars from the querys (the " AND") and run the querys
			mysql_query(substr('DELETE FROM `users` WHERE'.$tag, 0, -4));
			mysql_query(substr('DELETE FROM `votes` WHERE'.$tag, 0, -4));
			mysql_query(substr('DELETE FROM `xbt_users` WHERE'.$tag, 0, -4));
			mysql_query(substr('DELETE FROM `xbt_files_users` WHERE'.$tag, 0, -4));
		}
				
	}*/
	
	//shoutbox cleanup
	//if($_CFG['clean_shout'] > 0)
	//{
		$deltime = time() - 259200;//(($_CFG['clean_shout'] * 24) * 60) * 60;
		$query = cmysql_query("DELETE FROM ".SQL_PREFIX."shoutbox WHERE time < ".$deltime);
	//}
	cmysql_query('UPDATE `'.SQL_PREFIX.'settings` SET `value` = '.time().' WHERE `name` = \'clean_last_run\'');
}

/*-----------------------
# This is the function to PERMINANTLY delete 
# dead torrents from the system, its NOT active in 
# this first beta, but will be later on
#-----------------------*/

function clean_d_torrents(){
	global $_CFG;
	
	//set the local variables
	$count = 0;
	$deltime = (($_POST['time'] * 24) * 60) * 60;
	
	//get the dead torrents
	$query = mysql_query("SELECT `torrentid`, `info_hash` FROM `".SQL_PREFIX."torrents` WHERE `dtime` > $deltime AND `dead` = 1"); 
	while($res = mysql_fetch_array($query)){
		
		//increment $count
		$count++;
		
		//set our arrays so they dont get overwritten
		$tid[$res['torrentid']] = $res['torrentid'];
		$hash[$res['info_hash']] = $res['info_hash'];
	}
	
	//ONLY run the querys IF we have something to delete ;->
	if($count > 0){
	//start the querys
		$del1 = "DELETE FROM `".SQL_PREFIX."torrents` WHERE";
		$del2 = "DELETE FROM `".SQL_PREFIX."votes` WHERE";
		$del3 = "DELETE FROM `".SQL_PREFIX."tcomment` WHERE";
		$del4 = "DELETE FROM `".X_SQL_PREFIX."files` WHERE";
		$del5 = "DELETE FROM `".X_SQL_PREFIX."files_users` WHERE";
	}
	
	//set-up the torrentid baised querys, 
	//i know theres no need for the => $v but it looks prettyer :P
	foreach($tid as $k => $v){
		
		//delete the actual .torrent
		@unlink($_CFG['upload_path'].'/'.$k.'.torrent');
		
		//set the querys
		$del1 .= ' `torrentid` = '.$k.' AND';
		$del2 .= ' `tid` = '.$k.' AND';
		$del3 .= ' `tid` = '.$k.' AND';
	}
	
	//now the info_has baised querys
	foreach($hash as $k => $v){
		$del4 .= ' `info_hash` = '.$k.' AND';
		$del5 .= ' `info_hash` = '.$k.' AND';
	}
	
	//remove the " AND" (last 4 chars) from the end of the querys and run them
	mysql_query(substr($del1, 0, -4));
	mysql_query(substr($del2, 0, -4));
	mysql_query(substr($del3, 0, -4));
	mysql_query(substr($del4, 0, -4));
	mysql_query(substr($del5, 0, -4));
	
	//return the number of deleted torrents so we can feel good about what we've done :)
	echo $count;
}
	
/*------------
# logging of failed logins
#------------*/

function master_log($data){
	global $_CFG;
	
	cmysql_query('INSERT INTO `'.SQL_PREFIX.'log` VALUES (\'\',\''.$data.'\',NOW(),\''.$_SERVER['REMOTE_ADDR'].'\')');
}
?>